-- ----------------------------------------------------------------------------
-- Miner's Coffee and Pick
-- 		by Nasapunk88
-- ----------------------------------------------------------------------------
MCAP = {};
MinersCoffeeAndPickDB = MinersCoffeeAndPickDB or {};
--MinersCoffeeAndPickDestroy = MinersCoffeeAndPickDestroy or {};

--Get localized minimap zone text
_, MCAP.minimap = C_Garrison.GetBuildingInfo(61);

MCAP.items = {
	{ ["name"] = "MCAP_CoffeeButton",  --"Miner's Coffee"
	  ["id"] = 118897, 
	  ["button"] = nil
	},
	{ ["name"] = "MCAP_PickButton", --"Preserved Mining Pick"
	  ["id"] = 118903,
	  ["button"] = nil
	}
	--116913 "Peon's Mining Pick" , --35954 goat's milk for testing
};

function MCAP:updateButtons()
	for i = 1, #self.items do
		self:updateButton(self.items[i].button,self.items[i].id,i);
	end
end

function MCAP:updateButton(btn,id,num)
	local name = GetItemInfo(id);
	name, _, _, buff = UnitBuff("player",name);
	--If player is missing buff
	if name == nil or (id == 118897 and buff < 5 ) then
		btn:Show();
		local start, duration = GetItemCooldown(id);
		btn.cooldown:SetCooldown(start, duration);
		local count = GetItemCount(id);
		if count > 0 then
			if self.previous == 0 then
				btn:SetPoint("LEFT", self.frame, "LEFT", 0, 0);
			else
				btn:SetPoint("LEFT", self.items[self.previous].button, "RIGHT", 0, 0);
			end
			self.previous = num;
			btn.countString:SetText(format("%d",count));
			if buff and buff > 0 then
				btn.buffString:SetText(format("|cff00ff00%d",buff));
			else
				btn.buffString:SetText("");
			end
			btn.texture:SetDesaturated(false);
		elseif count == 0 then
			btn.countString:SetText("");
			btn.texture:SetDesaturated(true);
			btn:Hide();
		end
	else	--Buff is applied
		btn:Hide();
	end
end

function MCAP:createButton(btn,id)
	btn:Hide();
	btn:SetWidth(40);
	btn:SetHeight(40);
	btn:ClearAllPoints();
	btn:SetClampedToScreen(true);
	btn:SetPoint("LEFT", self.frame, "LEFT", 0, 0);
	--Right click to drag
	btn:EnableMouse(true);
	btn:RegisterForDrag("RightButton");
	btn:SetMovable(true);
	btn:SetScript("OnDragStart", function(self) self:GetParent():StartMoving(); end);
	btn:SetScript("OnDragStop", function(self) 
			self:GetParent():StopMovingOrSizing();
			self:GetParent():SetUserPlaced(false);
			local point, relativeTo, relativePoint, xOfs, yOfs = self:GetParent():GetPoint();
			MinersCoffeeAndPickDB.position = {point, nil, relativePoint, xOfs, yOfs};
		end);
	--Setup macro
	btn:SetAttribute("type", "macro");
	btn:SetAttribute("macrotext", format("/use item:%d",id));
	btn.countString = btn:CreateFontString(btn:GetName().."Count", "OVERLAY", "NumberFontNormal");
	btn.countString:SetPoint("BOTTOMRIGHT", btn, -3, 2);
	btn.countString:SetJustifyH("RIGHT");
	btn.buffString = btn:CreateFontString(btn:GetName().."Buff", "OVERLAY", "NumberFontNormal");
	btn.buffString:SetPoint("BOTTOMLEFT", btn, 2, 2);
	btn.buffString:SetJustifyH("LEFT");
	btn.icon = btn:CreateTexture(nil,"BACKGROUND");
	btn.icon:SetTexture(GetItemIcon(id));
	btn.icon:SetAllPoints(btn);
	btn.texture = btn.icon;
	btn.cooldown = CreateFrame("Cooldown",btn:GetName().."Cooldown", btn, "CooldownFrameTemplate");
	btn.cooldown:SetAllPoints();
	btn.cooldown:Show();
	--Tooltip
	btn:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self,"ANCHOR_TOP");
		GameTooltip:SetItemByID(format("%d",id));
		GameTooltip:SetClampedToScreen(true);
		GameTooltip:Show();
	  end);
	btn:SetScript("OnLeave",GameTooltip_Hide);
 end
 
function MCAP:OnEvent(event, ...)
	--Check for combat to avoid tainting frame
	if UnitAffectingCombat("player") then
		return
	end
	--Only load buttons when player is in their Mine
	if GetMinimapZoneText() == MCAP.minimap then
		self.frame:RegisterEvent("LOOT_CLOSED");
		self.frame:RegisterEvent("UNIT_AURA"); 
		self.frame:RegisterEvent("BAG_UPDATE"); 
		self.frame:Show();
		self.previous = 0;
		self:updateButtons();
	else --Hide anywhere else
		self.frame:Hide();
		self.frame:UnregisterEvent("LOOT_CLOSED");
		self.frame:UnregisterEvent("UNIT_AURA");
		self.frame:UnregisterEvent("BAG_UPDATE"); 
	end
end

------------------------------------------------
-- Slash Commands
------------------------------------------------
-- local function slashHandler(msg)
	-- msg = msg:lower() or "";
	-- if (msg == "enable" or msg == "yes") then
		-- MinersCoffeeAndPickDestroy.enableDelete = true;
		-- print("|cff33ff99MCAP|r: Deletion of "..select(2,GetItemInfo(118903)).." is enabled");
		-- MCAP:updateButtons();
	-- elseif (msg == "disable" or msg == "no") then
		-- MinersCoffeeAndPickDestroy.enableDelete = false;
		-- print("|cff33ff99MCAP|r: Deletion of "..select(2,GetItemInfo(118903)).." is disabled");
		-- MCAP:updateButtons();
	-- else
		-- print("|cff33ff99Miner's Coffee and Pick|r: Arguments to |cffffff78/mcap|r :");
		-- if MinersCoffeeAndPickDestroy.enableDelete then
			-- print("  |cff00ff00Deletion is currently |cffff0000Enabled|r");
		-- else
			-- print("  |cff00ff00Deletion is currently |cffff0000Disabled|r");
		-- end
		-- print("  |cffffff78 enable|r - Enable the automatic deletion of all "..select(2,GetItemInfo(118903)));
		-- print("  |cffffff78 disable|r - Disable deletion");
	-- end
-- end

-- SlashCmdList.MinersCoffeAndPick = function(msg) slashHandler(msg) end;
-- SLASH_MinersCoffeAndPick1 = "/mcap";
-- SLASH_MinersCoffeAndPick2 = "/minerscoffeeandpick";
-- SLASH_MinersCoffeAndPick3 = "/destroypicks";

--Helper functions
local function cout(msg, premsg)
	premsg = premsg or "[".."Miner's Coffee and Pick".."]"
	print("|cFFE8A317"..premsg.."|r "..msg);
end

local function coutBool(msg,bool)
	if bool then
		print(msg..": true");
	else
		print(msg..": false");
	end
end

--Main Frame
MCAP.frame = CreateFrame("Frame", "MCAP_Frame", UIParent);
MCAP.frame:Hide();
MCAP.frame:SetWidth(79);
MCAP.frame:SetHeight(39);
MCAP.frame:SetClampedToScreen(true);
MCAP.frame:SetFrameStrata("BACKGROUND");
MCAP.frame:SetMovable(true);
MCAP.frame:RegisterEvent("ZONE_CHANGED"); 
MCAP.frame:RegisterEvent("ZONE_CHANGED_INDOORS");
MCAP.frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
MCAP.frame:RegisterEvent("PLAYER_ENTERING_WORLD");
MCAP.frame:RegisterEvent("PLAYER_REGEN_ENABLED");
MCAP.frame:SetScript("OnEvent", function(self,event,...) MCAP:OnEvent(event,...) end);
MCAP.frame:SetScript("OnShow", function(self,event,...) 
	--Restore position
	if MinersCoffeeAndPickDB and MinersCoffeeAndPickDB.position then
		MCAP.frame:SetPoint(MinersCoffeeAndPickDB.position[1],UIParent,MinersCoffeeAndPickDB.position[3],MinersCoffeeAndPickDB.position[4],MinersCoffeeAndPickDB.position[5]);
	else
		MCAP.frame:SetPoint('CENTER', UIParent, 'CENTER', 0, 0);
	end
 end);
---Create button for each item
for i = 1, #MCAP.items do
	MCAP.items[i].button = CreateFrame("Button", MCAP.items[i].name, MCAP.frame, "SecureActionButtonTemplate,ActionButtonTemplate");
	MCAP:createButton(MCAP.items[i].button,MCAP.items[i].id);
end